## facet-analyser 0.0~git20210718121026.869873a+ds1

=== CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 3.8)

#Change PROJECT_NAME to the name of your project
PROJECT(FacetAnalyser)

#The following lines are required to use Dart
ENABLE_TESTING()
INCLUDE(CTest)

include(GNUInstallDirs)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(BUILD_SHARED_LIBS ON)

FIND_PACKAGE(ITK REQUIRED)
INCLUDE(${ITK_USE_FILE})

INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/third-party/VtkGlue/include/)
LINK_DIRECTORIES(${ITK_LIBRARY_DIRS})
LINK_LIBRARIES(${ITK_LIBRARIES})

#FIND_PACKAGE(VTK REQUIRED)
#INCLUDE(${VTK_USE_FILE})

FIND_PACKAGE(ParaView REQUIRED)
LINK_LIBRARIES(${VTK_LIBRARIES})

# build the plugin

set("_paraview_plugin_default_${CMAKE_PROJECT_NAME}" ON)
paraview_plugin_scan(
  PLUGIN_FILES      "${CMAKE_CURRENT_SOURCE_DIR}/Plugin/paraview.plugin"
  ENABLE_BY_DEFAULT ON
  PROVIDES_PLUGINS  plugins
  REQUIRES_MODULES  required_modules)

foreach (module IN LISTS required_modules)
  if (NOT TARGET "${module}")
    message(#FATAL_ERROR
      "Skipping example ${CMAKE_PROJECT_NAME}: Missing required module: "
      "${module}")
    return ()
  endif ()
endforeach ()

paraview_plugin_build(
  RUNTIME_DESTINATION "${CMAKE_INSTALL_BINDIR}"
  LIBRARY_DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  LIBRARY_SUBDIRECTORY "${PARAVIEW_PLUGIN_SUBDIR}"
  PLUGINS ${plugins}
  )

# tests

add_test(
  NAME basicPluginTest01
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/demos/
  COMMAND pvpython ${PROJECT_SOURCE_DIR}/scripts/pvsm2webgl.py -i 8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.pvsm -o ${PROJECT_SOURCE_DIR}/docs/demos/WebGL/8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.webgl -p ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/${PARAVIEW_PLUGIN_SUBDIR}/FacetAnalyser/FacetAnalyser.so
  )

add_test(
  NAME basicPluginTest02
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/demos/
  COMMAND pvpython ${PROJECT_SOURCE_DIR}/scripts/pvsm2x3d.py -i 8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.pvsm -o ../docs/demos/X3D/8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.x3d -p ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/${PARAVIEW_PLUGIN_SUBDIR}/FacetAnalyser/FacetAnalyser.so
  ) # relative path as it is stored in X3D

set_tests_properties(basicPluginTest01 PROPERTIES
  SKIP_REGULAR_EXCEPTION "ModuleNotFoundError: No module named 'paraview.web'")  # until paraview.web is available in Debian https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=991238

=== debian/changelog ===
facet-analyser (0.0~git20210718121026.869873a+ds1-2) unstable; urgency=medium

  * Bug fix: "Don't depend on PDAL", thanks to Bas Couwenberg who also
    provided a patch (closes: #1007131).

 -- Roland Mas <lolando@debian.org>  Wed, 20 Apr 2022 22:53:56 +0200

facet-analyser (0.0~git20210718121026.869873a+ds1-1) unstable; urgency=medium

  [ Picca Frédéric-Emmanuel ]
  * Initial release (closes: #996340).

  [ Roland Mas ]
  * Packaging fixes.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Oct 2021 19:39:51 +0200

=== debian/control ===
Source: facet-analyser
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>, Frédéric-Emmanuel Picca <picca@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libdouble-conversion-dev,
 libfftw3-dev,
 libgdcm-tools,
 libinsighttoolkit4-dev,
 liblz4-dev,
 libopengl-dev,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 libutfcpp-dev,
 libvtk7-dev,
 libvtkgdcm-cil,
 libvtkgdcm-dev,
 libvtkgdcm-java,
 libx11-dev,
 paraview-dev,
 python3-paraview,
 python3-vtkgdcm,
 qtbase5-dev,
 qttools5-dev,
 qtxmlpatterns5-dev-tools,
 vtk7,
 xalan,
 xvfb <!nocheck>,
 xauth <!nocheck>,
Standards-Version: 4.6.0
Homepage: https://github.com/picca/FacetAnalyser
Vcs-Git: https://salsa.debian.org/science-team/facet-analyser.git
Vcs-Browser: https://salsa.debian.org/science-team/facet-analyser
Rules-Requires-Root: no

Package: facet-analyser
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ParaView plugin for facet detection and angles measurement
 The presented ParaView plugin allows easy access to the algorithm
 described in Ref 1. It enables analysis of faceted objects that
 exhibit distortions in their digital representation, e.g. due to
 tomographic reconstruction artifacts. The contributed functionality
 can also be used outside ParaView in e.g. command-line programs. The
 code, data, a test and an example program are included.
 .
 Ref 1: Roman Grothausmann, Sebastian Fiechter, Richard Beare, Gaëtan
 Lehmann, Holger Kropf, Goarke Sanjeeviah Vinod Kumar, Ingo Manke, and
 John Banhart. Automated quantitative 3D analysis of faceting of
 particles in tomographic datasets. Ultramicroscopy, 122(0):65 – 75,
 2012. ISSN 0304- 3991. doi: 10.1016/j.ultramic.2012.07.024.

## facet-analyser 0.0~git20221121142040.6be10b8%2Bds1

=== debian/control ===
--- 
+++ 
@@ -9,16 +9,13 @@
  libdouble-conversion-dev,
  libfftw3-dev,
  libgdcm-tools,
- libinsighttoolkit4-dev,
+ libinsighttoolkit5-dev,
  liblz4-dev,
  libopengl-dev,
  libqt5opengl5-dev,
  libqt5svg5-dev,
  libutfcpp-dev,
- libvtk7-dev,
- libvtkgdcm-cil,
  libvtkgdcm-dev,
- libvtkgdcm-java,
  libx11-dev,
  paraview-dev,
  python3-paraview,
@@ -26,10 +23,23 @@
  qtbase5-dev,
  qttools5-dev,
  qtxmlpatterns5-dev-tools,
- vtk7,
  xalan,
  xvfb <!nocheck>,
  xauth <!nocheck>,
+ libogg-dev,
+ libtheora-dev,
+ libavcodec-dev,
+ libavdevice-dev,
+ libavfilter-dev,
+ libavformat-dev,
+ libavutil-dev,
+ libswresample-dev,
+ libswscale-dev,
+ libgl2ps-dev,
+ libgdal-dev,
+ libopenmpi-dev,
+ libglew-dev,
+ libfreetype-dev
 Standards-Version: 4.6.0
 Homepage: https://github.com/picca/FacetAnalyser
 Vcs-Git: https://salsa.debian.org/science-team/facet-analyser.git

## facet-analyser 0.0~git20221121142040.6be10b8+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,11 +60,18 @@
   COMMAND pvpython ${PROJECT_SOURCE_DIR}/scripts/pvsm2webgl.py -i 8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.pvsm -o ${PROJECT_SOURCE_DIR}/docs/demos/WebGL/8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.webgl -p ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/${PARAVIEW_PLUGIN_SUBDIR}/FacetAnalyser/FacetAnalyser.so
   )
 
+set_property(
+  TEST basicPluginTest01
+  PROPERTY SKIP_REGULAR_EXPRESSION "AttributeError"
+  )
+
 add_test(
   NAME basicPluginTest02
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/demos/
   COMMAND pvpython ${PROJECT_SOURCE_DIR}/scripts/pvsm2x3d.py -i 8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.pvsm -o ../docs/demos/X3D/8faced-rhombic-dodecahedron_twinned_simp+def_PVplugin.x3d -p ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/${PARAVIEW_PLUGIN_SUBDIR}/FacetAnalyser/FacetAnalyser.so
   ) # relative path as it is stored in X3D
 
-set_tests_properties(basicPluginTest01 PROPERTIES
-  SKIP_REGULAR_EXCEPTION "ModuleNotFoundError: No module named 'paraview.web'")  # until paraview.web is available in Debian https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=991238
+set_property(
+  TEST basicPluginTest02
+  PROPERTY SKIP_REGULAR_EXPRESSION "AttributeError"
+  )

=== Plugin/CMakeLists.txt ===
paraview_add_plugin(FacetAnalyser
  VERSION "1.0"
  MODULES FacetAnalysers
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/FacetAnalysers/vtk.module")

target_include_directories(FacetAnalyser
  PRIVATE ${PROJECT_SOURCE_DIR}/third-party/VtkGlue/include/
  )
target_link_libraries(FacetAnalyser
  PRIVATE ${ITK_LIBRARIES}
  )

=== Plugin/FacetAnalysers/CMakeLists.txt ===
# build the vtk modules and the paraview plugin

set(classes
  FacetAnalyser
  vtkGaussianSplatterExtended
  vtkMyHull
  )

vtk_module_add_module(FacetAnalysers
  FORCE_STATIC # Using FORCE_STATIC build the vtk module statically into the plugin library, to avoid confusion when loading
  CLASSES ${classes})

paraview_add_server_manager_xmls(
  XMLS  FacetAnalyser.xml)

# build and test the FacetAnalyserTest program

add_executable(FacetAnalyserTest
  FacetAnalyser.cxx
  FacetAnalyserTest.cxx
  vtkGaussianSplatterExtended.cxx
  vtkMyHull.cxx
  )

add_test(
  NAME basicTest01
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/testing/
  COMMAND FacetAnalyserTest 8faced-rhombic-dodecahedron_twinned_simplified.vtk
  )

# build and test the FacetAnalyserCLI program

add_executable(FacetAnalyserCLI
  FacetAnalyser.cxx
  FacetAnalyserCLI.cxx
  vtkGaussianSplatterExtended.cxx
  vtkMyHull.cxx
  )

add_test(
  NAME basicExampleTest01
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/demos/
  COMMAND FacetAnalyserCLI 8faced-rhombic-dodecahedron_twinned_010_deformed_wss.vtp 51 15 0.2 0.001 2 0 8faced-rhombic-dodecahedron_twinned_010_deformed_wss_FA.vtp
  )

=== docs/demos/SVGs/Makefile ===
### create distribution plot of inter-planar angles

.PHONY: all

all : 8faced-rhombic-dodecahedron_twinned_010_deformed_wss_FA.svg
all : 8faced-rhombic-dodecahedron_twinned_simp+def_01_04c_l01.png

# %_FA.vtp %_FA-hull.vtp %_FA-edges.vtp : %.vtp
# 	FacetAnalyserCLI $< 51 15 0.2 0.001 2 $*_FA.vtp $*_FA-hull.vtp $*_FA-edges.vtp # do not use $@ as this varies dep. on what Make demands first

%_FA.vtp : ../../../demos/%_FA.vtp # use output of basicExampleTest01
	ln -s $< $@

%_FA.csv : %_FA.vtp
	/opt/VTK-CLIs/bin/vtpFD2csv $< | datamash -t, --no-strict --filler="" transpose > $@ # vtpFD2csv from VTK-CLIs

%.svg : %.csv
	/opt/gnuplot/bin/gnuplot -e "datafile='$<'; outfile='$@'; bin=10; sigma=5; xmin=0; xmax=180; col='interplanarAngles'; sep=','; xlabel='interplanar angle (IPA)'" ~/gnuplot/hist-ar+kd.gp # gp-5.x allows referencing columns by header-name ;-)
	@test -f $@ # gnuplot' exit dose not allow specifying a return value

define BASE_TEX
\documentclass{article}
\usepackage{svg}
\pagenumbering{gobble}

\begin{document}
\includesvg[width=\textwidth, pretex=\large]{SVGFILE}
\end{document}
endef
export BASE_TEX

%_.tex : %.svg # _ to avoid collision with PDF created by inkscape
	$(file >$@,$(subst SVGFILE,$(basename $<),${BASE_TEX}))

%_.pdf : %_.tex
	pdflatex --shell-escape $<

%.png : %_.pdf
	convert -define png:exclude-chunks=date,time +set date:create +set date:modify  -density 150 $< -trim $@

=== docs/demos/X3D/Makefile ===

### convert X3D to XHTML (X3DOM/WebGL) with XSLT (also extract X3D from WebGL):
## http://www.web3d.org/wiki/index.php/STEP-NC_WebGL_Demo
## X3dToX3dom.xslt needs XSL2, so cannot be run with xsltproc (XSL1 only), but e.g. xalan is fine


.PHONY: all

all : 8faced-rhombic-dodecahedron_twinned_simp+def.xhtml

%.xhtml : %.x3d X3dToX3dom.xslt
	xalan -in $< -xsl $(lastword $^) -out $@


### let browser do it (does not work?):
## http://stackoverflow.com/questions/14324930/how-can-i-compile-an-xslt-file-to-bytecode-and-run-it-in-a-browser?rq=1
# %.xhtml : %.x3d
# 	cat - $< > $@ << EOF
# 		<?xml-stylesheet type="text/xsl" href="X3dToX3dom.xslt" ?>
# 	EOF
# 	sed -i '1N;s/\(.*\)\n\(.*\)/\2\n\1/' $@ # swap first two lines
# 	firefox $@

=== debian/changelog ===
facet-analyser (0.0~git20221121142040.6be10b8+ds1-3) unstable; urgency=medium

  * Build against paraview-dev's version of libvtk instead of depending on
    the soon-to-be-removed libvtk7-dev package, at least until the
    packaging status of vtk7/vtk9 and paraview's embedding of those is
    clarified.

 -- Roland Mas <lolando@debian.org>  Tue, 14 Feb 2023 18:42:18 +0100

Facet-analyser (0.0~git20221121142040.6be10b8+ds1-2) unstable; urgency=medium

  * Bug fix: "FTBFS: unsatisfiable build-dependencies: libvtkgdcm-cil,
    libvtkgdcm-java", thanks to Lucas Nussbaum (Closes: #1029247).
  * Remove those two packages from build-depends: they're no longer
    available, and they were not used during the build anyway.

 -- Roland Mas <lolando@debian.org>  Thu, 26 Jan 2023 17:13:27 +0100

facet-analyser (0.0~git20221121142040.6be10b8+ds1-1) unstable; urgency=medium

  * New upstream version 0.0~git20221121142040.6be10b8+ds1
  * Bug fix: "FTBFS: build-dependency not installable:
    libinsighttoolkit4-dev", thanks to Lucas Nussbaum (Closes: #1017211).
  * d/control: B-D replace libinsighttoolkit4-dev with libinsighttoolkit5-dev
  * Bug fix: "vtk[6,7] removal", thanks to gladk@debian.org</a>; (Closes:
    #1013158).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 21 Nov 2022 15:40:30 +0100

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
# package maintainers to append LDFLAGS

%:
	dh $@

override_dh_auto_test:
	xvfb-run dh_auto_test

override_dh_auto_build:
	(cd docs/demos/X3D ; xalan -in 8faced-rhombic-dodecahedron_twinned_simp+def.x3d -xsl X3dToX3dom.xslt -out 8faced-rhombic-dodecahedron_twinned_simp+def.xhtml)
	dh_auto_build

=== debian/watch ===
version=4
opts="mode=git, repacksuffix=+ds1, date=%Y%m%d%H%M%S, dversionmangle=s/\+ds\d+//, pgpmode=none" \
https://github.com/picca/FacetAnalyser.git \
HEAD debian uupdate
